let nodemailer = require("nodemailer");
const PushBullet = require("pushbullet");

module.exports = class Summon {
    constructor(client, from, incantation) {
        this.name = "Summon";
        this.client = client;
        this.summoner = from;
        this.incantation = incantation;
        this.spell = "alvoku la kreinton";
        this.cheatCode = "summon";
        this.casted = false;
        this.transporter = nodemailer.createTransport({
            sendmail: true,
            newline: "unix",
            path: "/usr/sbin/sendmail"
        });
        this.pusher = new PushBullet(client.config.api.pushbullet);
    }

    test() {
        if (this.incantation === this.spell) {
            this.casted = true;
            return this.cast();
        }
        
        return { say: false };
    }

    cast() {
        let response = {
            say: false,
            debug: {},
            content: ""
        };

        const subject = "You have been summoned!";
        const text = `Summoning request performed by ${this.summoner}`;

        this.transporter.sendMail({
            to: this.client.email,
            subject: subject,
            text: text
        }, (err, info) => {
            console.log("Summon::email", info);
            response.debug.email = info;
        });

        this.pusher.note(this.client.device, subject, text, (err, info) => {
            console.log("Summon::pusher", info);
            response.debug.pusher = info;
        });

        const success = `Superba ${this.summoner}! You have summoned`;

        response.say = true;
        response.content = `${success} ${this.client.config.author}!`;

        return response;
    }
}